'use strict';

let username = '<our userid>';
let password = '<our password>';
//let spaceGuid = '<our dev space GUID>';
//let spaceGuid = '<our prod space GUID>';
let spaceGuid = null;

listServiceInstances(username, password, null, spaceGuid, function(err, serviceInstances) {
	for (let serviceInstance of serviceInstances) {
		console.log(serviceInstance.name, ':', serviceInstance.guid);
	}
});

function login(cf, username, password) {
	return new Promise(function check(resolveMain, resolveError) {
		var info;
		cf.Controller.getInfo().then(function (result) {
			info = result;
			cf.UsersUAA.setEndPoint(result.authorization_endpoint);
			return cf.UsersUAA.login(username, password);
		}).then(function (result) {
			setToken(cf, result);
			resolveMain(info);
		}).catch(function() {
			resolveError('Invalid username or password.');
		})
	});
}

function setToken(cf, token){
	for (let nam in cf) {
		if (nam != 'endpoint') {
			cf[nam].setToken(token);
		}
	}
}

function loadEndpoint(endpoint) {
	if (!endpoint) {
		endpoint = (process.env.CF_ENDPOINT) ? process.env.CF_ENDPOINT : 'https://api.ng.bluemix.net';
	}

	if (endpoint.indexOf('http') < 0) {
		endpoint = "https://" + endpoint;
	}
	var cf = {endpoint: endpoint};

	cf.Controller = new (require("cf-client")).CloudController(endpoint);
	cf.UsersUAA = new (require("cf-client")).UsersUAA;
	cf.ServiceInstances = new (require("cf-client")).ServiceInstances(endpoint);

	return cf;
}

function listServiceInstances(username, password, endpoint, space_guid, callback) {
	let cf = loadEndpoint(endpoint);

	login(cf, username, password).then(function() {
		var filter = {};
		if (space_guid) {
			filter['q'] = 'space_guid:' + space_guid;
		}
		filter['results_per_page'] = 1000;
		return cf.ServiceInstances.getInstances(filter);
	}).then(function (results) {
		var serviceInstances = [];
		for (let obj of results.resources) {
			serviceInstances.push({
				guid: obj.metadata.guid,
				name: obj.entity.name
			});
		}
		return serviceInstances;
	}).then(function (results) {
		callback(null, results);
	}).catch(function(error) {
		callback(error);
	});
}